"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawSimpleTextarea = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const SimpleTextareaInner = (props) => {
    const { customClass, name, data = immutable_1.default.Map(), handleBlur, handleChange, handleFocus } = props, renderCount = react_1.default.useRef(0), value = data.get("value") || "", meta = data.get("meta") || immutable_1.default.Map(), theError = meta.get("theError"), isTouched = meta.get("isTouched"), onFocus = (event) => {
        if (typeof props.customOnFocus === "function") {
            props.customOnFocus(event, handleFocus, name);
        }
        else {
            handleFocus(name);
        }
    }, onBlur = (event) => {
        if (typeof props.customOnBlur === "function") {
            props.customOnBlur(event, handleBlur, name);
        }
        else {
            handleBlur(name);
        }
    }, onChange = (event) => {
        if (typeof props.customOnChange === "function") {
            props.customOnChange(event, handleChange, name);
        }
        else {
            handleChange(name, event.target.value);
        }
    }, hasError = typeof theError !== "undefined", showError = isTouched && hasError, theClass = `${showError ? "is-invalid" : ""} ${customClass ? customClass : ""} form-control`;
    react_1.default.useEffect(() => {
        renderCount.current += 1;
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", { className: "badge text-bg-primary" }, renderCount.current),
        react_1.default.createElement("textarea", Object.assign({ className: theClass, disabled: props.disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, value: value }, props.elementProps)),
        !props.hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null));
};
exports.RawSimpleTextarea = react_1.default.memo(SimpleTextareaInner);
//# sourceMappingURL=SimpleTextarea.js.map