"use strict";
/* eslint-disable require-unicode-regexp */
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearFloatOnBlur = exports.getFloatValueToStore = exports.isFloat = exports.floatToEnglishComma = void 0;
const floatToLocalComma = (raw) => String(raw).replace(".", ",");
const floatToEnglishComma = (raw) => String(raw).replace(",", "."), isFloat = (raw) => {
    const floatRegex = /^-?\d+(?:[.]\d*?)?$/;
    return floatRegex.test(raw);
}, getFloatValueToStore = (raw) => {
    const parsedFloat = (0, exports.floatToEnglishComma)(raw), parsedValue = parseFloat(parsedFloat), canGetNumericValue = (0, exports.isFloat)(parsedFloat) && !isNaN(parsedValue);
    if (canGetNumericValue) {
        return parsedValue;
    }
    return 0;
}, clearFloatOnBlur = (value, precision) => {
    const parts = floatToLocalComma(value).split(","), shouldRemoveComma = parts.length === 2 && (parts[1] === "" || Number(parts[1]) === 0), shouldCutToPrecision = parts.length === 2 && parts[1].length > precision;
    if (shouldRemoveComma) {
        return parts[0];
    }
    if (shouldCutToPrecision) {
        const [beforeDot] = parts, afterDot = parts[1].substring(0, precision);
        return `${beforeDot},${afterDot}`;
    }
    return value;
};
exports.floatToEnglishComma = floatToEnglishComma, exports.isFloat = isFloat, exports.getFloatValueToStore = getFloatValueToStore, exports.clearFloatOnBlur = clearFloatOnBlur;
//# sourceMappingURL=util-numeric.js.map