"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rawOnErrors = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const words_1 = require("react-immutable-form/words");
const InnerNestedList = ({ data }) => {
    const renderListContent = (value, key) => {
        if (immutable_1.default.Map.isMap(value) && immutable_1.default.Map.isMap(value.first())) {
            // If the value is an object or array, render it as a nested list
            return (react_1.default.createElement("ul", { className: "m-0 p-0 border-0", key: key },
                react_1.default.createElement("li", { className: "ps-2 mt-1", key: key },
                    react_1.default.createElement("span", { className: "fw-light me-1 fw-medium" }, key),
                    react_1.default.createElement("ul", { className: "m-0 p-0 border-0", key: key }, Array.from(value).map(([rowIndex, innerRow]) => (react_1.default.createElement("li", { className: "bg-danger-subtle list-group-item rounded-0 border-danger border-3 border-end-0 border-top-0 border-bottom-0 ps-2", key: `row${key}${rowIndex}` },
                        react_1.default.createElement("span", { className: "fw-light me-1" },
                            `${(0, words_1.getWords)().ROW} `,
                            react_1.default.createElement("span", { className: "badge text-bg-primary rounded-circle" }, Number(rowIndex) + 1)),
                        react_1.default.createElement("ul", { className: "m-0 p-0 border-0" }, Array
                            .from(innerRow)
                            .map((([fieldKey, fieldValue], fieldIndex) => (react_1.default.createElement("li", { className: "bg-danger-subtle list-group-item rounded-0 border-danger border-3 border-end-0 border-top-0 border-bottom-0 ps-2 py-0", key: `row${key}${rowIndex}-row-${fieldIndex}` },
                            react_1.default.createElement("ul", { className: "m-0 p-0 border-0", key: key }, renderListContent(fieldValue, fieldKey))))))))))))));
        }
        return (react_1.default.createElement("li", { className: "list-group-item rounded-0 border-0 ps-2 bg-danger-subtle", key: key },
            react_1.default.createElement("span", { className: "fw-light me-1 fw-bold" }, key),
            react_1.default.createElement("div", { className: "fw-light ms-1" }, value)));
    };
    return (react_1.default.createElement("ul", { className: "list-group bg-danger-subtle border-danger  border-3 border-end-0 border-top-0 border-bottom-0 rounded-0" }, immutable_1.default.Map.isMap(data) ? (Array.from(data).map(([key, value]) => renderListContent(value, key))) : (data.map(([key, value]) => (renderListContent(value, key))))));
}, NestedList = react_1.default.memo(InnerNestedList), performTranslation = (input) => {
    if (immutable_1.default.List.isList(input)) {
        return input.map((item) => performTranslation(item));
    }
    else if (immutable_1.default.Map.isMap(input)) {
        return input.reduce((acc, value, currentKey) => {
            const mapping = (0, words_1.getWords)().FIELDS_TO_DESCRIPTIONS, translatedKey = mapping[currentKey] || currentKey, newTranslation = performTranslation(value);
            return acc.set(translatedKey, newTranslation);
        }, immutable_1.default.Map());
    }
    return input;
};
const rawOnErrors = (cb) => (errors) => {
    if (errors.size === 0) {
        return;
    }
    const result = (react_1.default.createElement("div", { className: "p-1" },
        react_1.default.createElement("div", { className: "text-danger" }, (0, words_1.getWords)().CHECK_THE_ERRORS),
        react_1.default.createElement("div", { className: "overflow-scroll", style: { maxHeight: 200 } },
            react_1.default.createElement(NestedList, { data: performTranslation(errors) })),
        react_1.default.createElement("div", { className: "text-center text-primary mt-2" }, (0, words_1.getWords)().TO_HIDE_CLICK_HERE)));
    cb(result);
};
exports.rawOnErrors = rawOnErrors;
//# sourceMappingURL=onErrors.js.map